
#ifndef LinkedList
#define LinkedList


typedef struct Node
{
	int data;
	struct Node * next;
} Node_t;


int add_head(Node_t **head, int data);       // adds an element before the head node
int add_after(Node_t **head, int data);      // adds an element after the node

int del_head(Node_t **head);                 // deletes an element before the head node
int del_after(Node_t **head);                // deletes an element after the node
int del_all(Node_t **head);                  // deletes all elements from this node on ..

void print_node(Node_t *node);               // prints all the nodes (from this node on ..)
Node_t *next_node(Node_t *node, int steps);  // goes X nodes forward (steps indicates the amount)
int count_node(Node_t *node);                // counts the elements (from this node on ..)

#endif
