#include <stdio.h>
#include <stdlib.h>

#include "linked-list.h"

int main()
{
	Node_t *head=NULL, *temp=NULL;
	int count;

	// add element to head (6), head has NULL, expected resault: 6
	add_head(&head, 6);

	print_node(head);

	// adding anothher two elements (9 and 10), before head. expected resault: 10 -> 9 -> 6
	add_head(&head, 9);
	add_head(&head, 10);

	print_node(head);

	// delete the last added element and add another insted (deletes 10, adds 11). expected resault: 11 -> 9 -> 6
	del_head(&head);
	add_head(&head, 11);

	print_node(head);

	// add two elements, but one after the other (add 3, and after that 13). expected resault: 3 -> 13 -> 11 -> 9 -> 6
	add_head(&head, 3);
	add_after(&head, 13);

	print_node(head);

	// go two steps forward and add another element after whatever you are on (8). expected resault: 3 -> 13 -> 11 -> 8 -> 9 -> 6
	temp = next_node(head, 2);
	add_after(&temp, 8);
	
	print_node(head);

	// delete whatever comes after temp (8)
	del_after(&temp);

	print_node(head);


	// ---------------------- question ----------------------
	// Ask yourself the next question: will del_head(&temp) work ?
	// Explain why.
	// In case it doesn't, what can we do in order to make such an action work ?
	// the answer to those questions are in the solution file. (if you can't answer, please implement the code)
	//
	// del_head(&temp);
	// ---------------------- continue ----------------------


	// print how many nodes are there. expected resault 5.
	printf("the amount of nodes are: %d\n", count = count_node(head));

	// add to the end of the list an element (2). expected resault: 3 -> 13 -> 11 -> 8 -> 9 -> 6 -> 2
	temp = next_node(head, count);
	add_after(&temp, 2);

	print_node(head);

	// delete the whole linked list. expected resault: all elements are freed and head == NULL
	del_all(&head);
	temp = NULL;

	return 0;
}
